/*
*	New C++ File starts here.
*	This file should be named fuzzy_tsn.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "fuzzy_tsn.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : fuzzy_tsFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
int fuzzy_tsFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case FUZZY_TS_HALT_TYPE:
		((FUZZY_TS_HALT *) buffer)->update(cms);
		break;
	case FUZZY_TS_INIT_TYPE:
		((FUZZY_TS_INIT *) buffer)->update(cms);
		break;
	case FUZZY_TS_RUN_TYPE:
		((FUZZY_TS_RUN *) buffer)->update(cms);
		break;
	case FUZZY_TS_SET_ADAPTATION_GAIN_TYPE:
		((FUZZY_TS_SET_ADAPTATION_GAIN *) buffer)->update(cms);
		break;
	case FUZZY_TS_SET_INPUT_GAINS_TYPE:
		((FUZZY_TS_SET_INPUT_GAINS *) buffer)->update(cms);
		break;
	case FUZZY_TS_SET_IN_MF_TYPE:
		((FUZZY_TS_SET_IN_MF *) buffer)->update(cms);
		break;
	case FUZZY_TS_SET_IN_UD_TYPE:
		((FUZZY_TS_SET_IN_UD *) buffer)->update(cms);
		break;
	case FUZZY_TS_SET_PREMISE_TYPE:
		((FUZZY_TS_SET_PREMISE *) buffer)->update(cms);
		break;
	case FUZZY_TS_SET_TS_COEFF_TYPE:
		((FUZZY_TS_SET_TS_COEFF *) buffer)->update(cms);
		break;
	case FUZZY_TS_STATUS_TYPE:
		((FUZZY_TS_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *fuzzy_ts_symbol_lookup(int type)
{
	switch(type)
	{
	case FUZZY_TS_HALT_TYPE:
		return "FUZZY_TS_HALT";
	case FUZZY_TS_INIT_TYPE:
		return "FUZZY_TS_INIT";
	case FUZZY_TS_RUN_TYPE:
		return "FUZZY_TS_RUN";
	case FUZZY_TS_SET_ADAPTATION_GAIN_TYPE:
		return "FUZZY_TS_SET_ADAPTATION_GAIN";
	case FUZZY_TS_SET_INPUT_GAINS_TYPE:
		return "FUZZY_TS_SET_INPUT_GAINS";
	case FUZZY_TS_SET_IN_MF_TYPE:
		return "FUZZY_TS_SET_IN_MF";
	case FUZZY_TS_SET_IN_UD_TYPE:
		return "FUZZY_TS_SET_IN_UD";
	case FUZZY_TS_SET_PREMISE_TYPE:
		return "FUZZY_TS_SET_PREMISE";
	case FUZZY_TS_SET_TS_COEFF_TYPE:
		return "FUZZY_TS_SET_TS_COEFF";
	case FUZZY_TS_STATUS_TYPE:
		return "FUZZY_TS_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for FUZZY_TS_SET_IN_MF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_SET_IN_MF::update(CMS *cms)
{
	cms->update(num_of_current_in_ud);
	cms->update(num_of_current_in_mf);
	cms->update(mf_type);
	cms->update(mf_center);
	cms->update(mf_spread);

}


/*
*	NML/CMS Update function for FUZZY_TS_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_RUN::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for FUZZY_TS_SET_ADAPTATION_GAIN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_SET_ADAPTATION_GAIN::update(CMS *cms)
{
	cms->update(eta);

}


/*
*	NML/CMS Update function for FUZZY_TS_SET_TS_COEFF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_SET_TS_COEFF::update(CMS *cms)
{
	cms->update(num_of_current_rule);
	cms->update(ts_coeff,3);

}


/*
*	NML/CMS Update function for FUZZY_TS_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_HALT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for FUZZY_TS_SET_INPUT_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_SET_INPUT_GAINS::update(CMS *cms)
{
	cms->update(input_gains,2);

}


/*
*	NML/CMS Update function for FUZZY_TS_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_INIT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for FUZZY_TS_SET_IN_UD
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_SET_IN_UD::update(CMS *cms)
{
	cms->update(num_of_current_in_ud);
	cms->update(gain);
	cms->update(first_center);
	cms->update(last_center);
	cms->update(mf_type);
	cms->update(spread);

}


/*
*	NML/CMS Update function for FUZZY_TS_SET_PREMISE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_SET_PREMISE::update(CMS *cms)
{
	cms->update(premise_type);

}


/*
*	NML/CMS Update function for FUZZY_TS_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
void FUZZY_TS_STATUS::update(CMS *cms)
{
	cms->update(sys_inputs,2);
	cms->update(ts_inputs,2);
	cms->update(fuzzy_ts_output);
	cms->update(premise_type);
	cms->update(adapatation_gain);
	cms->update(num_of_current_in_ud);
	cms->update(gain_for_in_ud);
	cms->update(num_of_current_in_mf);
	cms->update(type_of_current_in_mf);
	cms->update(center_of_current_in_mf);
	cms->update(spread_of_current_in_mf);
	cms->update(num_of_current_rule);
	cms->update(ts_coeff,3);

}

/*
*	Constructor for FUZZY_TS_SET_IN_MF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_SET_IN_MF::FUZZY_TS_SET_IN_MF()
	: RCS_CMD_MSG(FUZZY_TS_SET_IN_MF_TYPE,sizeof(FUZZY_TS_SET_IN_MF))
{
	num_of_current_in_ud = (int) 0;
	num_of_current_in_mf = (int) 0;
	mf_type = (int) 0;
	mf_center = (double) 0;
	mf_spread = (double) 0;

}

/*
*	Constructor for FUZZY_TS_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_RUN::FUZZY_TS_RUN()
	: RCS_CMD_MSG(FUZZY_TS_RUN_TYPE,sizeof(FUZZY_TS_RUN))
{

}

/*
*	Constructor for FUZZY_TS_SET_ADAPTATION_GAIN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_SET_ADAPTATION_GAIN::FUZZY_TS_SET_ADAPTATION_GAIN()
	: RCS_CMD_MSG(FUZZY_TS_SET_ADAPTATION_GAIN_TYPE,sizeof(FUZZY_TS_SET_ADAPTATION_GAIN))
{
	eta = (double) 0;

}

/*
*	Constructor for FUZZY_TS_SET_TS_COEFF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_SET_TS_COEFF::FUZZY_TS_SET_TS_COEFF()
	: RCS_CMD_MSG(FUZZY_TS_SET_TS_COEFF_TYPE,sizeof(FUZZY_TS_SET_TS_COEFF))
{
	num_of_current_rule = (int) 0;
	/*
	* The array ts_coeff should be initialized here.
	*/


}

/*
*	Constructor for FUZZY_TS_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_HALT::FUZZY_TS_HALT()
	: RCS_CMD_MSG(FUZZY_TS_HALT_TYPE,sizeof(FUZZY_TS_HALT))
{

}

/*
*	Constructor for FUZZY_TS_SET_INPUT_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_SET_INPUT_GAINS::FUZZY_TS_SET_INPUT_GAINS()
	: RCS_CMD_MSG(FUZZY_TS_SET_INPUT_GAINS_TYPE,sizeof(FUZZY_TS_SET_INPUT_GAINS))
{
	/*
	* The array input_gains should be initialized here.
	*/


}

/*
*	Constructor for FUZZY_TS_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_INIT::FUZZY_TS_INIT()
	: RCS_CMD_MSG(FUZZY_TS_INIT_TYPE,sizeof(FUZZY_TS_INIT))
{

}

/*
*	Constructor for FUZZY_TS_SET_IN_UD
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_SET_IN_UD::FUZZY_TS_SET_IN_UD()
	: RCS_CMD_MSG(FUZZY_TS_SET_IN_UD_TYPE,sizeof(FUZZY_TS_SET_IN_UD))
{
	num_of_current_in_ud = (int) 0;
	gain = (double) 0;
	first_center = (double) 0;
	last_center = (double) 0;
	mf_type = (int) 0;
	spread = (double) 0;

}

/*
*	Constructor for FUZZY_TS_SET_PREMISE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_SET_PREMISE::FUZZY_TS_SET_PREMISE()
	: RCS_CMD_MSG(FUZZY_TS_SET_PREMISE_TYPE,sizeof(FUZZY_TS_SET_PREMISE))
{
	premise_type = (int) 0;

}

/*
*	Constructor for FUZZY_TS_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 13:34:05 EST 2000
*/
FUZZY_TS_STATUS::FUZZY_TS_STATUS()
	: RCS_STAT_MSG(FUZZY_TS_STATUS_TYPE,sizeof(FUZZY_TS_STATUS))
{
	/*
	* The array sys_inputs should be initialized here.
	*/

	/*
	* The array ts_inputs should be initialized here.
	*/

	fuzzy_ts_output = (double) 0;
	premise_type = (int) 0;
	adapatation_gain = (double) 0;
	num_of_current_in_ud = (int) 0;
	gain_for_in_ud = (double) 0;
	num_of_current_in_mf = (int) 0;
	type_of_current_in_mf = (int) 0;
	center_of_current_in_mf = (double) 0;
	spread_of_current_in_mf = (double) 0;
	num_of_current_rule = (int) 0;
	/*
	* The array ts_coeff should be initialized here.
	*/


}

