/*
	fuzzy_ts_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		FUZZY_TS_MODULE

	MODIFICATIONS:
	Fri Dec 15 15:49:34 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "fuzzy_ts.hh"	// definition of FUZZY_TS_MODULE

// flag signifying main loop is to terminate
int fuzzy_ts_module_done = 0;

//signal handler for ^C
extern "C" void fuzzy_ts_module_quit(int sig);
void fuzzy_ts_module_quit(int sig)
{
	fuzzy_ts_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int fuzzy_ts_module_run();

int fuzzy_ts_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	FUZZY_TS_MODULE *fuzzy_ts = new FUZZY_TS_MODULE();

	// set the SIGINT handler
	signal(SIGINT, fuzzy_ts_module_quit);

	// enter main loop
	while(!fuzzy_ts_module_done)
	{
		fuzzy_ts->controller();

		timer->wait();
	}

	// Delete Modules
	delete fuzzy_ts;

	// Delete Timer
	delete timer;
}

